const Koa = require('koa')
const app = new Koa()
const path = require('path')
const fs = require('fs')
const config = require('./config')

// require middleware
const cors = require('kcors')
const koaBody = require('koa-body')
const koaSession = require('koa-session2')
const koaLogger = require('koa-logger')
const koaMount = require('koa-mount')
const koaStatic = require('koa-static')

if (process.env['NODE_ENV'] !== 'test') {
  app.use(koaLogger())
}

app.use(cors())
app.use(koaSession())
app.use(koaStatic(path.resolve(__dirname, 'public'), {
  maxage: 600000
}))
const rootRouter = require('./route')

app.use(rootRouter.allowedMethods())
app.use(rootRouter.routes())

const server = app.listen(config.port, () => {
  console.log(`start on port ${server.address().port}`)
})

module.exports = server